scala.tools.nsc.transform.patmat.Logic

# PropositionalLogic

#### trait PropositionalLogic extends AnyRef

Source
  Logic.scala

Linear Supertypes
AnyRef, Any
Known Subclasses
CNF, CommonSubconditionElimination, MatchAnalyzer, MatchApproximator, MatchOptimizer, OptimizingMatchTranslator, Solver, TreesAndTypesDomain
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. PropositionalLogic
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### trait AbsVar extends AnyRef

2. #### case class And(a: Prop, b: Prop) extends Prop with Product with Serializable

3. #### abstract type Const

4. #### case class Eq(p: Var, q: Const) extends Prop with Product with Serializable

5. #### abstract type Formula

6. #### abstract type FormulaBuilder

7. #### type Model = Map[Sym, Boolean]

8. #### case class Not(a: Prop) extends Prop with Product with Serializable

9. #### case class Or(a: Prop, b: Prop) extends Prop with Product with Serializable

10. #### class Prop extends AnyRef

11. #### trait PropMap extends AnyRef

12. #### trait PropTraverser extends AnyRef

13. #### abstract case class Sym(variable: Var, const: Const) extends Prop with Product with Serializable

14. #### abstract type Tree

15. #### abstract type Type

16. #### abstract type TypeConst <: Const

17. #### trait TypeConstExtractor extends AnyRef

18. #### class UniqueSym extends Sym

19. #### abstract type ValueConst <: Const

20. #### trait ValueConstExtractor extends AnyRef

21. #### abstract type Var <: AbsVar

22. #### trait VarExtractor extends AnyRef

### Abstract Value Members

1. #### abstract val EmptyModel: Model

2. #### abstract val NoModel: Model

3. #### abstract val NullConst: Const

4. #### abstract def TypeConst: TypeConstExtractor

5. #### abstract def ValueConst: ValueConstExtractor

6. #### abstract val Var: VarExtractor

7. #### abstract def addFormula(buff: FormulaBuilder, f: Formula): Unit

8. #### abstract def andFormula(a: Formula, b: Formula): Formula

9. #### abstract def cnfString(f: Formula): String

10. #### abstract def eqFreePropToSolvable(p: Prop): Formula

11. #### abstract def findAllModelsFor(f: Formula): List[Model]

12. #### abstract def findModelFor(f: Formula): Model

13. #### abstract def formulaBuilder: FormulaBuilder

14. #### abstract def prepareNewAnalysis(): Unit

15. #### abstract def reportWarning(message: String): Unit

16. #### abstract def simplifyFormula(a: Formula): Formula

17. #### abstract def toFormula(buff: FormulaBuilder): Formula

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from PropositionalLogic to any2stringadd[PropositionalLogic] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (PropositionalLogic, B)

   Implicit information
     This member is added by an implicit conversion from PropositionalLogic to ArrowAssoc[PropositionalLogic] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### def /\(props: Iterable[Prop]): Prop

6. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

7. #### object AnalysisBudget

8. #### object False extends Prop with Product with Serializable

9. #### object Sym extends Serializable

10. #### object True extends Prop with Product with Serializable

11. #### def \/(props: Iterable[Prop]): Prop

12. #### final def asInstanceOf[T0]: T0

    Definition Classes
      Any

13. #### def clone(): AnyRef

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

14. #### def ensuring(cond: (PropositionalLogic) ⇒ Boolean, msg: ⇒ Any): PropositionalLogic

    Implicit information
      This member is added by an implicit conversion from PropositionalLogic to Ensuring[PropositionalLogic] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

15. #### def ensuring(cond: (PropositionalLogic) ⇒ Boolean): PropositionalLogic

    Implicit information
      This member is added by an implicit conversion from PropositionalLogic to Ensuring[PropositionalLogic] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

16. #### def ensuring(cond: Boolean, msg: ⇒ Any): PropositionalLogic

    Implicit information
      This member is added by an implicit conversion from PropositionalLogic to Ensuring[PropositionalLogic] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

17. #### def ensuring(cond: Boolean): PropositionalLogic

    Implicit information
      This member is added by an implicit conversion from PropositionalLogic to Ensuring[PropositionalLogic] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

18. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

19. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

20. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

21. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from PropositionalLogic to StringFormat[PropositionalLogic] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

22. #### def gatherVariables(p: Prop): Set[Var]

23. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

24. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

25. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

26. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

27. #### final def notify(): Unit

    Definition Classes
      AnyRef

28. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

29. #### def propToSolvable(p: Prop): Formula

30. #### def removeVarEq(props: List[Prop], modelNull: Boolean = false): (Formula, List[Formula])

31. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

32. #### def toString(): String

    Definition Classes
      AnyRef → Any

33. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

34. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

35. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

36. #### def →[B](y: B): (PropositionalLogic, B)

    Implicit information
      This member is added by an implicit conversion from PropositionalLogic to ArrowAssoc[PropositionalLogic] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from PropositionalLogic to any2stringadd[PropositionalLogic]

### Inherited by implicit conversion StringFormat from PropositionalLogic to StringFormat[PropositionalLogic]

### Inherited by implicit conversion Ensuring from PropositionalLogic to Ensuring[PropositionalLogic]

### Inherited by implicit conversion ArrowAssoc from PropositionalLogic to ArrowAssoc[PropositionalLogic]

### Ungrouped